<template>
  <div id="template"> Carte agrandie
    <div id = "map"> </div>

    <div id="Liste_criteres" class="dropdown">
        <b-dropdown id="dropdown-1" text="Liste de Citères" class="m-md-2">
          <b-dropdown-item>First Action</b-dropdown-item>
          <b-dropdown-item>Second Action</b-dropdown-item>
          <b-dropdown-item>Third Action</b-dropdown-item>
          <b-dropdown-divider></b-dropdown-divider>
        </b-dropdown>

    </div>
    <div id="Liste_spots">
    <!-- <b-list-group>
        <b-list-group-item v-on:click= "onSpotClick" v-for="(spots, index) in name" :key="index" href="#">{{spots}}</b-list-group-item>
    </b-list-group> -->
    </div>
  </div>

</template>

<script>
import mapboxgl from 'mapbox-gl/dist/mapbox-gl.js'

mapboxgl.accessToken = 'pk.eyJ1IjoibGxlZGluaCIsImEiOiJja2pza3dzb2sxMmtvMnpqeDg1bnJldzB4In0.AtwAS_tK-RbadW7ikVcL5g'

export default {
  data () {
    return {
      latlng: [],
      description: [],
      name: [],

      selected: null,
      options: [
        { value: null, text: 'Selectionner un critère' },
        { value: 'a', text: 'Critère 1' },
        { value: 'b', text: 'Critère 2' },
        { value: 'd', text: 'Critère 3', disabled: true }
      ]
    }
  },

  methods: {
    getLatlng: function () {
      return fetch('/spot')
        .then(response => response.json())
        .then(data => {
          const latlng = []
          let k = 0
          for (let i = 0; i < data.data.length; i++) {
            latlng[k] = data.data[i].latitude
            latlng[k + 1] = data.data[i].longitude
            k += 2
            this.description.push(data.data[i].description)
            this.name.push(data.data[i].nom)
          }
          this.latlng = latlng
        })
    }
  },
  async mounted () {
    await this.getLatlng()

    // eslint-disable-next-line no-unused-vars
    const map = new mapboxgl.Map({
      container: 'map',
      style: 'mapbox://styles/mapbox/streets-v11',
      center: [1.433333, 43.600000],
      zoom: 11.15
    })

    // Add zoom and rotation controls to the map.
    map.addControl(new mapboxgl.NavigationControl())

    const features = []
    let k = 0
    for (let i = 0; i < this.latlng.length; i += 2) {
      const feature = {
        type: 'Feature',
        properties: {
          description: '<h1>' + this.name[k] + '</h1> <p>' + this.description[k] + '</p>'
        },
        geometry: {
          type: 'Point',
          coordinates: [this.latlng[i + 1], this.latlng[i]]
        }
      }
      k += 1
      features.push(feature)
    }
    map.on('load', () => {
      map.loadImage(
        'https://docs.mapbox.com/mapbox-gl-js/assets/custom_marker.png',
        // Add an image to use as a custom marker
        function (error, image) {
          if (error) throw error
          map.addImage('custom-marker', image)
          map.addSource('places', {
            type: 'geojson',
            data: {
              type: 'FeatureCollection',
              features
            }
          })

          map.addLayer({
            id: 'places',
            type: 'symbol',
            source: 'places',
            layout: {
              'icon-image': 'custom-marker',
              'icon-allow-overlap': true
            }
          })
        })
    })

    map.on('click', 'places', function (e) {
      console.log('click')
      var coordinates = e.features[0].geometry.coordinates.slice()
      var description = e.features[0].properties.description

      // Ensure that if the map is zoomed out such that multiple
      // copies of the feature are visible, the popup appears
      // over the copy being pointed to.
      while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360
      }

      new mapboxgl.Popup()
        .setLngLat(coordinates)
        .setHTML(description)
        .addTo(map)
    })

    map.on('mouseenter', 'places', function () {
      map.getCanvas().style.cursor = 'pointer'
    })

    // Change it back to a pointer when it leaves.
    map.on('mouseleave', 'places', function () {
      map.getCanvas().style.cursor = ''
    })
  }

}
</script>

<style scoped>
  #map {
    width: 100%;
    height: 900px;
    grid-row-start: 2;
    grid-column-start: 2;
    grid-column-end: span 6;
  }
  #template {
    display: grid;
    grid-template-columns: 20% 20% 20% 20% 20%;
    grid-template-rows: 10% 90%;
  }
  #Liste_critères {
    grid-row-start: 1;
  }

  #Liste_spots {
    grid-column-start: 1;
  }

</style>
